/*
 * grsecurity - access control and security hardening for Linux
 * Copyright (C) 2001-2017 Bradley Spengler, Open Source Security, Inc.
 * http://www.grsecurity.net spender@grsecurity.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef __GRSOCK_H
#define __GRSOCK_H

extern void gr_attach_curr_ip(const struct sock *sk);
extern int gr_handle_sock_all(const int family, const int type,
			      const int protocol);
extern int gr_handle_sock_server(const struct sockaddr *sck);
extern int gr_handle_sock_server_other(const struct sock *sck);
extern int gr_handle_sock_client(const struct sockaddr *sck);
extern int gr_search_connect(struct socket * sock,
			     struct sockaddr_in * addr);
extern int gr_search_bind(struct socket * sock,
			  struct sockaddr_in * addr);
extern int gr_search_listen(struct socket * sock);
extern int gr_search_accept(struct socket * sock);
extern int gr_search_socket(const int domain, const int type,
			    const int protocol);

#endif
