#ifndef AUTOSLAB_H_INCLUDED
#define AUTOSLAB_H_INCLUDED

#include "gcc-common.h"
#include "gcc-ksyms.h"

// usercopy attrs
extern struct attribute_spec alloc_flags_attr;
extern struct attribute_spec alloc_attr;

void autoslab_get_alloc_attrs(tree fndecl, tree *count_arg, tree *size_arg, tree *flags_arg, tree *flags_kind);

// plugin <-> target interaction
void autoslab_find_decls(void *event_data, void *data __unused);
extern GTY(()) tree autoslab_info_type;

enum kmem_call_names {
	KMEM_CACHE_ALLOC = 0,
	KMEM_CACHE_ALLOC_NODE,
	KMEM_CACHE_NUM
};

#ifdef __cplusplus
static inline enum kmem_call_names& operator++(enum kmem_call_names& kmem_call)
{
	if (kmem_call >= KMEM_CACHE_NUM)
		gcc_unreachable();

	kmem_call = static_cast<enum kmem_call_names>(static_cast<unsigned int>(kmem_call) + 1);
	return kmem_call;
}
#endif

extern GTY(()) struct kmem_cache_decl {
	const char * const name;
	tree decl;
	bool used;
	bool preserved;
} kmem_cache_decls[KMEM_CACHE_NUM];

EXPORTED_CONST struct ggc_root_tab gt_ggc_r_gt_autoslab[];

// misc
extern bool verbose;

// gcc passes
#if BUILDING_GCC_VERSION >= 4009
gimple_opt_pass *make_pass_autoslab(gcc::context *);
#else
struct opt_pass *make_pass_autoslab(void);
#endif

#endif
