#ifndef UTILITIES_H_INCLUDED
#define UTILITIES_H_INCLUDED

#include "gcc-common.h"

// align_init_text_sections
extern unsigned int align_init_text_bits;
void align_init_text_sections(void *event_data, void *data __unused);

// asm_include
extern const char *asm_include;
void asm_include_start_unit(void __unused *gcc_data, void __unused *user_data);

// colorize
#if BUILDING_GCC_VERSION < 4009
bool should_colorize(void);
void colorize_start_unit(void *gcc_data __unused, void *user_data __unused);
#endif

// context
EXPORTED_CONST struct ggc_root_tab gt_ggc_r_gt_checker[];
void context_start_unit(void __unused *gcc_data, void __unused *user_data);
extern struct attribute_spec context_attr;
extern GTY(()) tree context_function_decl;
extern GTY(()) tree context_error_decl;

// emergency_dump
#if BUILDING_GCC_VERSION < 8000
#if BUILDING_GCC_VERSION < 4006
extern void (*old_internal_error)(const char *, va_list *);
void emergency_dump_internal_error_function(const char *msgid, va_list *ap);
#else
extern void (*old_internal_error)(diagnostic_context *, const char *, va_list *);
void emergency_dump_internal_error_function(diagnostic_context *dc, const char *msgid, va_list *ap);
#endif
#endif

// fix_esra
unsigned int fix_esra_execute(void);

// ksyms
EXPORTED_CONST struct ggc_root_tab gt_ggc_r_gt_ksyms[];
#if BUILDING_GCC_VERSION < 4007
void ksyms_find_all_decls(void *event_data, void *data __unused);
#endif
void ksyms_find_decls(void *event_data, void *data __unused);

// null_deref
extern bool report_null_deref;

// once
extern struct attribute_spec read_once_attr;
extern struct attribute_spec write_once_attr;
unsigned int once_after_execute(void);

// section_type
extern struct attribute_spec section_type_flags_attr;
void section_type_start_unit(void __unused *gcc_data, void __unused *user_data);

// gcc passes
#if BUILDING_GCC_VERSION >= 4009
//simple_ipa_opt_pass *make_pass_colorize_rearm(gcc::context *);
gimple_opt_pass *make_pass_context(gcc::context *);
gimple_opt_pass *make_pass_once_before(gcc::context *);
gimple_opt_pass *make_pass_once_after(gcc::context *);
gimple_opt_pass *make_pass_fix_esra(gcc::context *);
#else
struct opt_pass *make_pass_colorize_rearm(void);
struct opt_pass *make_pass_context(void);
struct opt_pass *make_pass_once_before(void);
struct opt_pass *make_pass_once_after(void);
struct opt_pass *make_pass_fix_esra(void);
#endif

#endif
